package com.vendor.burn;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.consoles.FastbootConsoleFactory;
import com.vendor.burn.log.Log;
import com.vendor.burn.model.devices.ISaveable;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.utilitily.FileUtils;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashSet;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

public class Activator extends AbstractUIPlugin {
  public static final String PLUGIN_ID = "com.vendor.burn";
  
  private static com.vendor.burn.Activator plugin;
  
  private HashSet<ISaveable> saveables = new HashSet<>();
  
  private FastbootEvent event;
  
  public static Image getImage(String imagePath) {
    ImageDescriptor imageDesc = null;
    if (!PlatformUI.isWorkbenchRunning()) {
      URL url = com.vendor.burn.Activator.class.getResource(".");
      if (url == null)
        return null; 
      String urlStr = url.toString();
      int index = urlStr.indexOf("com.vendor.burn");
      urlStr = urlStr.substring(0, index + "com.vendor.burn".length());
      urlStr = urlStr + urlStr;
      try {
        url = new URL(urlStr);
        InputStream sourceStream = url.openStream();
        ImageData source = new ImageData(sourceStream);
        ImageData mask = source.getTransparencyMask();
        return new Image(null, source, mask);
      } catch (MalformedURLException malformedURLException) {
      
      } catch (IOException iOException) {}
    } else {
      imageDesc = imageDescriptorFromPlugin("com.vendor.burn", imagePath);
    } 
    if (imageDesc == null)
      return null; 
    return imageDesc.createImage();
  }
  
  public void start(BundleContext context) throws Exception {
    super.start(context);
    setPlugin(this);
    try {
      File dir = Log.getLogFileDir().toFile();
      if (!dir.exists() && 
        !dir.mkdirs())
        return; 
      File file = Log.getLogFile().toFile();
      if (file.exists() && 
        file.length() > 268435456L)
        FileUtils.deleteFile(file); 
    } catch (Exception exception) {}
  }
  
  public void stop(BundleContext context) throws Exception {
    setPlugin(null);
    super.stop(context);
    FastbootConsoleFactory.clearConsole();
  }
  
  public static com.vendor.burn.Activator getDefault() {
    return plugin;
  }
  
  public FastbootEvent getEvent() {
    return this.event;
  }
  
  public void setEvent(FastbootEvent event) {
    this.event = event;
  }
  
  public void add(ISaveable saveable) {
    this.saveables.add(saveable);
  }
  
  public HashSet<ISaveable> getSaveables() {
    return this.saveables;
  }
  
  public static void setPlugin(com.vendor.burn.Activator plugin) {
    com.vendor.burn.Activator.plugin = plugin;
  }
}
